import React from 'react';
import { Icon, Rate } from 'antd';
import { antiAssign } from '../../../../utils/utils';
import s from './index.less';
import { ApolloRateProps } from '../editInterface';
import { onBlurFn } from '../onBlurFn';

export const ApolloRate = (props: ApolloRateProps) => {
    const { onChange, columnConfig } = props;
    const selfProps = antiAssign(props, [
        'columnConfig',
        'onChange',
        'tableId',
        'rowData',
        'cellRenderProps',
        'maxPopHeight',
        'getCalendarContainer',
        'getCalendarContainer',
        'origin',
        'disableOptions',
        'rowId',
        'onBlurFn',
        'getInstanceDetail',
    ]);
    selfProps.disabled = !!props.disabled;

    const changeValue = (value) => {
        if (typeof onChange === 'function') {
            if (typeof onBlurFn === 'function') {
                onBlurFn({ ...props, value });
            }
            onChange(value);
        }
    };
    if (columnConfig.requiredFlag) {
        selfProps.allowClear = false;
    }
    return (
        <Rate
            className={s.rate}
            {...selfProps}
            character={<Icon type="like" theme="filled" />}
            onChange={changeValue}
        />
    );
};
